﻿#-------------------------------------------------------------------------------
#      L A    L E C O N   D E   P I A N O   Version 1
# Créé par Martin, le 25/05/2015 en Python 3.2
#-------------------------------------------------------------------------------
from tkinter import *
from random import *

#-------------------------------------------------------------------------------
#                        P R O C E D U R E S
#-------------------------------------------------------------------------------
def extrait_note():
   # Extrait de 'morceau' la note courante dans 'note'
   global note, morceau


   # Extraction de la note courante
   note=""
   while morceau[0]!=" " :
       note=note+morceau[0]
       if len(morceau)>1 : morceau=morceau[1:len(morceau)]
       else :
           morceau=""
           break

   # On enlève " - "
   if len(morceau)>0 : morceau=morceau[3:len(morceau)]

   # Mise à jour lmorceau
   lmorceau.config(text=morceau)
#-------------------------------------------------------------------------------
def remet_note() :
    # Remet 'note' dans 'morceau' au cas où on s'est trompé
    global note, morceau
    morceau=note+" - "+morceau
    lmorceau.config(text=morceau)
#-------------------------------------------------------------------------------
def do_joué() :
    global note, morceau

    extrait_note()

    if note=="Do" :
        lnote_reponse.config(text="DO", bg="green")
    else :
        lnote_reponse.config(text="DO", bg="red")
        remet_note()

        # Test fin de traitement
    if len(morceau)==0 : fin_du_programme()
#-------------------------------------------------------------------------------
def ré_joué() :
    global note, morceau

    extrait_note()

    if note=="Ré" :
        lnote_reponse.config(text="RE", bg="green")
    else :
        lnote_reponse.config(text="RE", bg="red")
        remet_note()

        # Test fin de traitement
    if len(morceau)==0 : fin_du_programme()
#-------------------------------------------------------------------------------
def mi_joué() :
    global note, morceau

    extrait_note()

    if note=="Mi" :
        lnote_reponse.config(text="MI", bg="green")
    else :
        lnote_reponse.config(text="MI", bg="red")
        remet_note()

        # Test fin de traitement
    if len(morceau)==0 : fin_du_programme()
#-------------------------------------------------------------------------------
def fa_joué() :
    global note, morceau

    extrait_note()

    if note=="Fa" :
        lnote_reponse.config(text="FA", bg="green")
    else :
        lnote_reponse.config(text="FA", bg="red")
        remet_note()

        # Test fin de traitement
    if len(morceau)==0 : fin_du_programme()
#-------------------------------------------------------------------------------
def sol_joué() :
    global note, morceau

    extrait_note()

    if note=="Sol" :
        lnote_reponse.config(text="SOL", bg="green")
    else :
        lnote_reponse.config(text="SOL", bg="red")
        remet_note()

        # Test fin de traitement
    if len(morceau)==0 : fin_du_programme()
#-------------------------------------------------------------------------------
def la_joué() :
    global note, morceau

    extrait_note()

    if note=="La" :
        lnote_reponse.config(text="LA", bg="green")
    else :
        lnote_reponse.config(text="LA", bg="red")
        remet_note()

        # Test fin de traitement
    if len(morceau)==0 : fin_du_programme()
#-------------------------------------------------------------------------------
def si_joué() :
    global note, morceau

    extrait_note()

    if note=="Si" :
        lnote_reponse.config(text="SI", bg="green")
    else :
        lnote_reponse.config(text="SI", bg="red")
        remet_note()

        # Test fin de traitement
    if len(morceau)==0 : fin_du_programme()
#-------------------------------------------------------------------------------
def fin_du_programme() :
    print("C'est fini!")
    fenetre.destroy()
    sys.exit(1)
#-------------------------------------------------------------------------------
#                   I N I T I A L I S A T T I O N
#-------------------------------------------------------------------------------

# Création de la fenêtre
fenetre=Tk()
fenetre.geometry("420x420")
fenetre.title("La leçon de piano")
fenetre.configure(bg="brown")


# Labels

ltitre = Label(fenetre, text="La leçon de piano", font="Times 20 ", bg="brown")
ltitre.place(x = 100, y = 1)

# Clavier touches blanches
btouche1=Button(fenetre, bg="white", height="10", width="5", command=do_joué)
btouche1.place(x = 50, y = 50)

btouche2=Button(fenetre, bg="white", height="10", width="5", command=ré_joué)
btouche2.place(x = 95, y = 50)

btouche3=Button(fenetre, bg="white", height="10", width="5", command=mi_joué)
btouche3.place(x = 140, y = 50)

btouche4=Button(fenetre, bg="white", height="10", width="5", command=fa_joué)
btouche4.place(x = 185, y = 50)

btouche5=Button(fenetre, bg="white", height="10", width="5", command=sol_joué)
btouche5.place(x = 230, y = 50)

btouche6=Button(fenetre, bg="white", height="10", width="5", command=la_joué)
btouche6.place(x = 275, y = 50)

btouche7=Button(fenetre, bg="white", height="10", width="5", command=si_joué)
btouche7.place(x = 320, y = 50)


# Clavier touches noires
bnoire1=Button(fenetre, bg="black", height="7", width="3")
bnoire1.place(x = 78, y = 50)

bnoire2=Button(fenetre, bg="black", height="7", width="3")
bnoire2.place(x = 123, y = 50)

bnoire3=Button(fenetre, bg="black", height="7", width="3")
bnoire3.place(x = 213, y = 50)

bnoire4=Button(fenetre, bg="black", height="7", width="3")
bnoire4.place(x = 258, y = 50)

bnoire5=Button(fenetre, bg="black", height="7", width="3")
bnoire5.place(x = 303, y = 50)

# Morceau à reproduire
lmorceau=Label(fenetre,bg="brown", font="Times 14")
lmorceau.place(x=15,y=280)

# Note réponse
lnote_reponse=Label(fenetre, font="Times 20", text="", bg="brown" )
lnote_reponse.place(x=190, y=330)

# A jouer
la_jouer=Label(fenetre,text="A jouer :", bg="brown", font="Times 16 ")
la_jouer.place(x=180, y=240)


# Génération de la séquence de notes
nb_notes=randint(5,10)   # Nombre de notes
morceau=""

for i in range(nb_notes) :

    note=randint(1,7)

    if note==1 : morceau=morceau+"Do"
    if note==2 : morceau=morceau+"Ré"
    if note==3 : morceau=morceau+"Mi"
    if note==4 : morceau=morceau+"Fa"
    if note==5 : morceau=morceau+"Sol"
    if note==6 : morceau=morceau+"La"
    if note==7 : morceau=morceau+"Si"

    if i!=nb_notes-1 : morceau=morceau+" - "

lmorceau.config(text=morceau)


fenetre.mainloop()





